package com.huiju.estateagents.property.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 月租车缴费订单表
 * </p>
 *
 * @author jobob
 * @since 2019-05-13
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("ta_user_license_order")
public class TaUserLicenseOrder implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 小区ID
     */
    private Integer orgId;

    /**
     * 人员ID
     */
    private Integer taUserId;

    /**
     * 订单号
     */
    private String orderNumber;

    /**
     * 支付状态  0：未支付  1: 已支付 2: 正在支付中 3:已关闭
     */
    private String orderStatus;

    /**
     * 创建人
     */
    private Integer createUser;

    /**
     * 创建时间
     */
    private LocalDateTime createDate;

    /**
     * 更新人
     */
    private Integer updateUser;

    /**
     * 更新时间
     */
    private LocalDateTime updateDate;

    /**
     * 延期月份
     */
    private Integer extensionMonth;

    /**
     * 延期费用
     */
    private String extensionPrice;

    /**
     * 缴费手机号
     */
    private String paymentTel;

    /**
     * 缴费人姓名
     */
    private String paymentName;

    /**
     * 缴费方式 0是微信支付 2是支付宝 
     */
    private String paymentType;

    /**
     * 到期时间
     */
    private LocalDateTime expireDate;

    /**
     * 单价费用
     */
    private String unitPrice;

    /**
     * 停车场
     */
    private String parkingLot;

    /**
     * 车牌号
     */
    private String licensePlate;


}
